//
//   dグL̋L
//   2001/3/15   GetMousePos̗p
//   MaskMan̑eL̋LQlɂčւ@͕
// CAD ver5.5ȍ~@Ή
//

Program SiageKigou;

var
  X1, Y1, X2, Y2, X3, Y3, X4, Y4 : double;
  ang, dummy1, dummy2, dummy3: double;
  A, B, M, C : double;
  S, H : double;
  N, I, J, LineID : integer;
  work : string;

procedure SiageKigou0(X00, Y00, H0:double; N0:integer; S0, ang0:double; t0:string);
var
  R01, X01, Y01, X02, Y02, X03, Y03 : double;
  XA0, YA0, XA1, YA1, XA2, YA2, IA0 : double;

Begin
  If N0=0 Then  // g`L̍}
    Begin
      R01 :=H0/2.0;
      X01 :=X00-R01*COS( 30);
      Y01 :=Y00+R01*SIN( 30);
      X02 :=X00-(R01/COS( 30));
      Y02 :=Y00;
      XA0 :=X00+R01*2.0*COS( 30);
      YA0 :=Y00+R01;
      XA1 :=XA0+R01*COS( 30);
      YA1 :=YA0-R01*SIN( 30);
      XA2 :=XA0+(R01/COS( 30));
      YA2 :=YA0;

      rotation(X00, Y00, ang0);
      ARC(X00,Y00,R01,30.0,150.0);
      line(X01,Y01,X02,Y02);
      ARC(XA0,YA0,R01,210.0,330.0);
      line(XA1,YA1,XA2,YA2);
    End;

  If N0 > 0 Then // OpL̍}
    Begin
      R01 := H0/cos(30);
      X01 := X00-R01*cos( 60);
      Y01 := Y00+R01*sin( 60);
      X02 := X00+R01*cos( 60);
      Y02 := Y00+R01*sin( 60);

      rotation(X00, Y00, ang0);

      FOR i:= 1 TO N0 DO
        begin
          IA0 := R01*(i-1);
          XA0 := X00+IA0;
          YA0 := Y00;
          XA1 := X01+IA0;
          YA1 := Y01;
          XA2 := X02+IA0;
          YA2 := Y02;

          line(XA0,YA0,XA1,YA1);
          line(XA1,YA1,XA2,YA2);
          line(XA0,YA0,XA2,YA2);
        END;

    dummy1 := Length(t0)*S0*GetDimScale();
    if dummy1 > 0 then
      begin;
        dummy3 := R01*N0;
        if dummy1 > dummy3 then
          dummy2 := X01-(dummy1-dummy3)/2.0
        else
          dummy2 := X01+(dummy3-dummy1)/2.0;
        text(dummy2, Y00+H0*1.1, 0, S0, t0);
      END;
  end;
End;

procedure SiageKigou1(X10, Y10, H0:double; N0:integer; S1, ang1:double; t1:string);
var
  R11, X11, Y11, X12, Y12, X13, Y13 : double;
  XB0, YB0, XB1, YB1, XB2, YB2, JB1 : double;

Begin
  If N0=0 Then // g`L̍}
    Begin
      R11 :=H0/2.0;
      X11 :=X10+R11*COS( 30);
      Y11 :=Y10-R11*SIN( 30);
      X12 :=X10+(R11/COS( 30));
      Y12 :=Y10;
      XB0 :=X10-R11*2.0*COS( 30);
      YB0 :=Y10-R11;
      XB1 :=XB0-R11*COS( 30);
      YB1 :=YB0+R11*SIN( 30);
      XB2 :=XB0-(R11/COS( 30));
      YB2 :=YB0;

      rotation(X10, Y10, ang1);
      ARC(X10,Y10,R11,210.0,330.0);
      line(X11,Y11,X12,Y12);
      ARC(XB0,YB0,R11,30.0,150.0);
      line(XB1,YB1,XB2,YB2);
    End;

  If N0 > 0 Then // OpL̍}
    Begin
      R11 := H0/cos(30);
      X11 := X10+R11*cos( 60);
      Y11 := Y10-R11*sin( 60);
      X12 := X10-R11*cos( 60);
      Y12 := Y10-R11*sin( 60);

    rotation(X10, Y10, ang1);

    FOR J := 1 TO N0 DO
      begin
        JB1 := R11*(J-1);
        XB0 := X10+JB1;
        YB0 := Y10;
        XB1 := X11+JB1;
        YB1 := Y11;
        XB2 := X12+JB1;
        YB2 := Y12;

        line(XB0,YB0,XB1,YB1);
        line(XB1,YB1,XB2,YB2);
        line(XB0,YB0,XB2,Y12);
      END;

    dummy1 := Length(t1)*S1*GetDimScale();
    if dummy1 > 0 then
      begin
        dummy3 := R11*N0;
        if dummy1 > dummy3 then
          dummy2 := X12 - (dummy1-dummy3)/2.0
        else
          dummy2 := X12 + (dummy3-dummy1)/2.0;
        text(dummy2, Y11-S1*1.2*GetDimScale(), 0, S1, t1);
      END;
  end;
End;

begin
  while true do
    Begin
      InitDlg;
      AddImage(10,10,'dグLp.bmp');
      work := '';
      AddEdit(1,54,33,55,20, work);
      AddLabel( 30, 122,80,13,'S ()      =');
      AddLabel( 30, 152,80,13,'H (dグL) =');
      AddLabel( 30, 182,80,13,'N (OpL̐) =');

      AddEdit(2, 140,120,60,20,'3.2');
      AddEdit(3, 140,150,60,20,'5.0');
      AddEdit(4, 140,180,60,20,'2');
      If ShowDlg(230, 250, 'dグL') <> True Then
        Exit;

      work := GetDlgText(1);
      S  := StrToFloat(GetDlgText(2));
      H  := StrToFloat(GetDlgText(3));
      N  := StrToINT(GetDlgText(4));

      If (N < 5) And (N >= 0) Then // OpL̐̃`FbN
        Break;
      MsgBox('OpL̐łBS܂');
    End;
    
    linetype(0);

  while true do
    begin
      Message('IĂ');
      if GetLineInfo(X1, Y1, X2, Y2) = -1 then
        exit;

// 2001/03/15@GetMousePospőIP
      GetMousePos(X3, Y3);
      Message('');

      if X1 = X2 then   // ̏ꍇ
        if X3 > X1 then //̉Ȅꍇ
          SiageKigou1(X1, Y3, H, N, S, 90, work)
        else            //̍̏ꍇ
          SiageKigou0(X1, Y3, H, N, S, 90, work)
      else if Y1 = Y2 then  //̏ꍇ
        if Y3 >= Y1 then//̏㑤̏ꍇ
          SiageKigou0(X3, Y1, H, N, S, 0, work)
        else            //̉̏ꍇ
          SiageKigou1(X3, Y1, H, N, S, 0, work)
      else
        begin
          //I̎̌vZ
          A := (Y1-Y2)/(X1-X2);
          B := (X1*Y2-X2*Y1)/(X1-X2);
          //I񂾓_ʂ蒼钼̌vZ
          M := -1.0 / A;
          C := Y3-M*X3;
          //_̌vZ
          X4 := (B-C)/(M-A);
          Y4 := M*X4+C;
          ang := ArcTan(A);
          if Y3 >= Y4 then
            SiageKigou0(X4, Y4, H, N, S, ang, work)
          else
            SiageKigou1(X4, Y4, H, N, S, ang, work);
        end;
    end;
end.
